<br />

This page describes how to configure database flags for Cloud SQL, and
lists the flags that you can set for your instance. You use database flags
for many operations, including adjusting MySQL parameters, adjusting
options, and configuring and tuning an instance.

> [!NOTE]
> **Note:** Some database flag settings can affect instance availability or stability, and remove the instance from the [Cloud SQL SLA](https://cloud.google.com/sql/sla). For information about these flags, see [Operational Guidelines](https://docs.cloud.google.com/sql/docs/operational-guidelines.md.txt#database_flag_values).

In some cases, setting
one flag may require that you set another flag to fully enable the
functionality you want to use. For example, to enable
[slow query logging](https://dev.mysql.com/doc/refman/8.4/en/slow-query-log.html),
you must set both the `slow_query_log` flag to `on` and the `log_output` flag
to `FILE` to make your logs available using the Google Cloud console Logs Explorer.

When you set, remove, or modify a flag for a database instance, the database
might be restarted. The flag value is then persisted for the instance until you
remove it. If the instance is the source of a replica, and the instance is
restarted, the replica is also restarted to align with the current configuration
of the instance.

## Configure database flags

The following sections cover common flag management tasks.

### Set a database flag

### Console

1. In the [Google Cloud console](https://console.cloud.google.com/project/_/sql/instances), select the project that contains the Cloud SQL instance for which you want to set a database flag.
2. Open the instance and click **Edit**.
3. Go to the **Flags** section.
4. To set a flag that has not been set on the instance before, click **Add item**, choose the flag from the drop-down menu, and set its value.
5. Click **Save** to save your changes.
6. Confirm your changes under **Flags** on the Overview page.

### gcloud

Edit the instance:

```bash
gcloud sql instances patch INSTANCE_NAME --database-flags=FLAG1=VALUE1,FLAG2=VALUE2
```

This command will overwrite all database flags
previously set. To keep those and add new ones, include the values for all
flags you want set on the instance; any flag not specifically included is
set to its default value. For flags that don't take a value, specify the
flag name followed by an equals sign ("=").

For example, to set the `general_log`,
`skip_show_database`, and `wait_timeout` flags, you
can use the following command:

```bash
gcloud sql instances patch INSTANCE_NAME \
  --database-flags=general_log=on,skip_show_database=on,wait_timeout=200000
```

### Terraform

To add database flags, use a [Terraform resource](https://registry.terraform.io/providers/hashicorp/google/latest/docs/resources/sql_database_instance).

```terraform
resource "google_sql_database_instance" "instance" {
  database_version = "MYSQL_8_0"
  name             = "mysql-instance"
  region           = "us-central1"
  settings {
    database_flags {
      name  = "general_log"
      value = "on"
    }
    database_flags {
      name  = "skip_show_database"
      value = "on"
    }
    database_flags {
      name  = "wait_timeout"
      value = "200000"
    }
    disk_type = "PD_SSD"
    tier      = "db-n1-standard-2"
  }
  # set `deletion_protection` to true, will ensure that one cannot accidentally delete this instance by
  # use of Terraform whereas `deletion_protection_enabled` flag protects this instance at the GCP level.
  deletion_protection = false
}
```

#### Apply the changes

To apply your Terraform configuration in a Google Cloud project, complete the steps in the
following sections.

## Prepare Cloud Shell

1. Launch [Cloud Shell](https://shell.cloud.google.com/).
2. Set the default Google Cloud project
   where you want to apply your Terraform configurations.

   You only need to run this command once per project, and you can run it in any directory.

   ```
   export GOOGLE_CLOUD_PROJECT=PROJECT_ID
   ```

   Environment variables are overridden if you set explicit values in the Terraform
   configuration file.

## Prepare the directory

Each Terraform configuration file must have its own directory (also
called a *root module*).

1. In [Cloud Shell](https://shell.cloud.google.com/), create a directory and a new file within that directory. The filename must have the `.tf` extension---for example `main.tf`. In this tutorial, the file is referred to as `main.tf`.

   ```
   mkdir DIRECTORY && cd DIRECTORY && touch main.tf
   ```
2. If you are following a tutorial, you can copy the sample code in each section or step.

   Copy the sample code into the newly created `main.tf`.

   Optionally, copy the code from GitHub. This is recommended
   when the Terraform snippet is part of an end-to-end solution.
3. Review and modify the sample parameters to apply to your environment.
4. Save your changes.
5. Initialize Terraform. You only need to do this once per directory.

   ```
   terraform init
   ```

   Optionally, to use the latest Google provider version, include the `-upgrade`
   option:

   ```
   terraform init -upgrade
   ```

## Apply the changes

1. Review the configuration and verify that the resources that Terraform is going to create or update match your expectations:

   ```
   terraform plan
   ```

   Make corrections to the configuration as necessary.
2. Apply the Terraform configuration by running the following command and entering `yes` at the prompt:

   ```
   terraform apply
   ```

   Wait until Terraform displays the "Apply complete!" message.
3. [Open your Google Cloud project](https://console.cloud.google.com/) to view the results. In the Google Cloud console, navigate to your resources in the UI to make sure that Terraform has created or updated them.

> [!NOTE]
> **Note:** Terraform samples typically assume that the required APIs are enabled in your Google Cloud project.

#### Delete the changes

To delete your changes, do the following:

1. To disable deletion protection, in your Terraform configuration file set the `deletion_protection` argument to `false`.

   ```
   deletion_protection =  "false"
   ```
2. Apply the updated Terraform configuration by running the following command and entering `yes` at the prompt:

   ```
   terraform apply
   ```

<!-- -->

3. Remove resources previously applied with your Terraform configuration by running the following
   command and entering `yes` at the prompt:

   ```
   terraform destroy
   ```

### REST v1

To set a flag for an existing database:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags":
    [
      {
        "name": "flag_name",
        "value": "flag_value"
      }
    ]
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/v1/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

For example, to set the `general_log` flag for an existing
database use:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags":
    [
      {
        "name": "general_log",
        "value": "on"
      }
    ]
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/v1/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

If there are existing flags configured for the database, modify the previous
command to include them. The `PATCH` command overwrites the existing
flags with the ones specified in the request.

### REST v1beta4

To set a flag for an existing database:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags":
    [
      {
        "name": "flag_name",
        "value": "flag_value"
      }
    ]
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

For example, to set the `general_log` flag for an existing
database use:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags":
    [
      {
        "name": "general_log",
        "value": "on"
      }
    ]
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

If there are existing flags configured for the database, modify the previous
command to include them. The `PATCH` command overwrites the existing
flags with the ones specified in the request.

### Clear all flags to their default values

### Console

1. In the [Google Cloud console](https://console.cloud.google.com/project/_/sql/instances), select the project that contains the Cloud SQL instance for which you want to clear all flags.
2. Open the instance and click **Edit**.
3. Open the **Database flags** section.
4. Click the **X** next to all of the flags shown.
5. Click **Save** to save your changes.

### gcloud

Clear all flags to their default values on an instance:

```bash
gcloud sql instances patch INSTANCE_NAME \
--clear-database-flags
```

You are prompted to confirm that the instance will be restarted.

### REST v1

To clear all flags for an existing instance:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags": []
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/v1/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

### REST v1beta4

To clear all flags for an existing instance:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
PATCH https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id
```


Request JSON body:

```
{
  "settings":
  {
    "databaseFlags": []
  }
}
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
curl -X PATCH \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     -H "Content-Type: application/json; charset=utf-8" \
     -d @request.json \
     "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Save the request body in a file named `request.json`,
and execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method PATCH `
    -Headers $headers `
    -ContentType: "application/json; charset=utf-8" `
    -InFile request.json `
    -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "kind": "sql#operation",
  "targetLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id",
  "status": "PENDING",
  "user": "user@example.com",
  "insertTime": "2020-01-21T22:43:37.981Z",
  "operationType": "UPDATE",
  "name": "operation-id",
  "targetId": "instance-id",
  "selfLink": "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/operations/operation-id",
  "targetProject": "project-id"
}
```

### View current values of database flags

To view all current values of the MySQL system variables, log into your instance with the `mysql` client and enter the following statement:

<br />

```sql
 SHOW VARIABLES;
```

Note that you can change the value only for supported flags (as listed below).

### Determine which database flags have been set for an instance

To see which flags have been set for a Cloud SQL instance:

<br />

### Console

1. In the [Google Cloud console](https://console.cloud.google.com/project/_/sql/instances), select the project that contains the Cloud SQL instance for which you want to see the database flags that have been set.
2. Select the instance to open its **Instance Overview** page.

   The database flags that have been set are listed under the
   **Database flags** section.

### gcloud

Get the instance state:

```bash
gcloud sql instances describe INSTANCE_NAME
```

In the output, database flags are listed under the `settings` as
the collection `databaseFlags`. For more information
about the representation of the flags in the output, see
[Instances Resource Representation](https://docs.cloud.google.com/sql/docs/mysql/admin-api/rest/v1beta4/instances.md.txt).

<br />

### REST v1

To list flags configured for an instance:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
GET https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
curl -X GET \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method GET `
    -Headers $headers `
    -Uri "https://sqladmin.googleapis.com/v1/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "settings":
  {
    "authorizedGaeApplications": [],
    "tier": "machine-type",
    "kind": "sql#settings",
    "availabilityType": "REGIONAL",
    "pricingPlan": "PER_USE",
    "replicationType": "SYNCHRONOUS",
    "activationPolicy": "ALWAYS",
    "ipConfiguration":
    {
      "privateNetwork": "projects/project-id/global/networks/default",
      "authorizedNetworks": [],
      "ipv4Enabled": false
    },
    "locationPreference":
    {
      "zone": "zone",
      "kind": "sql#locationPreference"
    },
    "databaseFlags": [
      {
        "name": "general_log",
        "value": "on"
      }
    ],
    "dataDiskType": "PD_SSD",
    "maintenanceWindow":
    {
      "kind": "sql#maintenanceWindow",
      "hour": 0,
      "day": 0
    },
    "backupConfiguration":
    {
      "startTime": "03:00",
      "kind": "sql#backupConfiguration",
      "enabled": true,
      "binaryLogEnabled": true
    },
    "settingsVersion": "54",
    "storageAutoResizeLimit": "0",
    "storageAutoResize": true,
    "dataDiskSizeGb": "10"
  }
}
```

In the output, look for the `databaseFlags` field.

### REST v1beta4

To list flags configured for an instance:


Before using any of the request data,
make the following replacements:

- <var translate="no">project-id</var>: The project ID
- <var translate="no">instance-id</var>: The instance ID


HTTP method and URL:

```
GET https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id
```

To send your request, expand one of these options:

#### curl (Linux, macOS, or Cloud Shell)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) , or by using [Cloud Shell](https://docs.cloud.google.com/shell/docs.md.txt), which automatically logs you into the `gcloud` CLI . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
curl -X GET \
     -H "Authorization: Bearer $(gcloud auth print-access-token)" \
     "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id"
```

#### PowerShell (Windows)

> [!NOTE]
> **Note:** The following command assumes that you have logged in to the `gcloud` CLI with your user account by running [`gcloud init`](https://docs.cloud.google.com/sdk/gcloud/reference/init) or [`gcloud auth login`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/login.md.txt) . You can check the currently active account by running [`gcloud auth list`](https://docs.cloud.google.com/sdk/gcloud/reference/auth/list.md.txt).


Execute the following command:

```
$cred = gcloud auth print-access-token
$headers = @{ "Authorization" = "Bearer $cred" }

Invoke-WebRequest `
    -Method GET `
    -Headers $headers `
    -Uri "https://sqladmin.googleapis.com/sql/v1beta4/projects/project-id/instances/instance-id" | Select-Object -Expand Content
```

You should receive a JSON response similar to the following:

#### Response

```
{
  "settings":
  {
    "authorizedGaeApplications": [],
    "tier": "machine-type",
    "kind": "sql#settings",
    "availabilityType": "REGIONAL",
    "pricingPlan": "PER_USE",
    "replicationType": "SYNCHRONOUS",
    "activationPolicy": "ALWAYS",
    "ipConfiguration":
    {
      "privateNetwork": "projects/project-id/global/networks/default",
      "authorizedNetworks": [],
      "ipv4Enabled": false
    },
    "locationPreference":
    {
      "zone": "zone",
      "kind": "sql#locationPreference"
    },
    "databaseFlags": [
      {
        "name": "general_log",
        "value": "on"
      }
    ],
    "dataDiskType": "PD_SSD",
    "maintenanceWindow":
    {
      "kind": "sql#maintenanceWindow",
      "hour": 0,
      "day": 0
    },
    "backupConfiguration":
    {
      "startTime": "03:00",
      "kind": "sql#backupConfiguration",
      "enabled": true,
      "binaryLogEnabled": true
    },
    "settingsVersion": "54",
    "storageAutoResizeLimit": "0",
    "storageAutoResize": true,
    "dataDiskSizeGb": "10"
  }
}
```

In the output, look for the `databaseFlags` field.

<br />

<br />

### Flags managed by Cloud SQL

Cloud SQL adjusts certain system flags depending on the instance machine
type.

[innodb_buffer_pool_instances](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_instances)
:
    - 1 for db-f1-micro and db-g1-small.
    - 1 if RAM \< 7.5 GB.
    - 2 if 7.5 GB \<= RAM \< 13 GB.
    - 4 if 13 GB \<= RAM \< 26 GB.
    - 8 if RAM \>= 26 GB.

## Supported flags

The flags supported in Cloud SQL are the most commonly requested flags for
MySQL. Flags not mentioned in this section are not supported.


For a given flag, Cloud SQL might support a different value or range
from the corresponding MySQL parameter or option.

<br />

The flags apply to all versions of MySQL supported by Cloud SQL
except where noted.

[A](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-a) \| [B](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-b) \| [C](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-c) \| [D](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-d) \| [E](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-e) \| [F](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-f) \| [G](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-g) \| [H](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-h) \| [I](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-i) \| [L](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-l) \| [M](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-m) \| [N](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-n) \| [O](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-o) \| [P](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-p) \| [Q](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-q) \| [R](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-r) \| [S](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-s) \| [T](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-t) \| [U](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-u) \| [W](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#mysql-w)

> [!NOTE]
> **Note**: The flag is removed in MySQL 9.7.

Cloud SQL Flag Type  
Acceptable Values and Notes Restart  
Required? [activate_all_roles_on_login](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_activate_all_roles_on_login) `boolean`   
`on` \| `off`   
default: `off`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [activate_mandatory_roles](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_sysvar_activate_mandatory_roles) `boolean`   
`on` \| `off`   
default: `on`  

> [!NOTE]
> **Note**: The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [autocommit](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_autocommit) `boolean`   
`on` \| `off`   
default: `on` No [auto_increment_increment](https://dev.mysql.com/doc/refman/8.4/en/replication-options-source.html#sysvar_auto_increment_increment) `integer`   
`1` ... ` 65535` No [auto_increment_offset](https://dev.mysql.com/doc/refman/8.4/en/replication-options-source.html#sysvar_auto_increment_offset) `integer`  
`1` ... ` 65535` No [automatic_sp_privileges](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_automatic_sp_privileges) `boolean`   
`on` \| `off`   
default: `on` No [back_log](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_back_log) `integer`  
`1` ... ` 65535`   
default: `max_connections`   
MySQL 8.4 and earlier: `4000`   
MySQL 9.7 and later: `10000`

> [!NOTE]
> **Note:** The `max_connections` flag enables the permitted backlog to adjust to the maximum permitted number of simultaneous client connections.

Yes [binlog_cache_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_cache_size) `integer`  
`4096` ... ` 9223372036854775807` No [binlog_expire_logs_seconds](https://dev.mysql.com/doc/refman/8.0/en/replication-options-binary-log.html#sysvar_binlog_expire_logs_seconds) `integer`  
`0` or `86400 (1 day)` ... `4294967295 (max value)`  
Default is 86400, which equals 1 day.

See the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-expire-logs)
section for more information about this flag.
No [binlog_group_commit_sync_delay](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_group_commit_sync_delay) 0 ... 1000000

Supported in MySQL 5.7 and later

Default is **0**.
No [binlog_group_commit_sync_no_delay_count](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_group_commit_sync_no_delay_count) 0 ... 1000000

Supported in MySQL 5.7 and later

Default is **0**.
No [binlog_gtid_simple_recovery](https://dev.mysql.com/doc/refman/8.4/en/replication-options-gtids.html#sysvar_binlog_gtid_simple_recovery) `boolean`   
`on` \| `off`   
default: `on` Yes [binlog_order_commits](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_order_commits) `boolean`   
`on` \| `off`   
default: `on`

See the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-binlog-order)
section for more information about this flag.
No [binlog_row_image](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_row_image) `enumeration`  
`full` (default), `minimal`, or `noblob` No [binlog_row_metadata](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_row_metadata) `enumeration`  
`full` or `minimal` (default) No [binlog_row_value_options](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_row_value_options) `string`  
`PARTIAL_JSON` or `''`  
default: `''` No [binlog_rows_query_log_events](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_rows_query_log_events) `boolean`   
`on` \| `off`   
default: `off` No [binlog_stmt_cache_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_stmt_cache_size) `4096` ... ` 9223372036854775807` No [binlog_transaction_compression](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_transaction_compression) `boolean`   
`on` \| `off`   
default: `off`

Changes to `binlog_transaction_compression` take effect only
after the next `START REPLICA` statement.

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.20 and later for Cloud SQL.

> [!NOTE]
> **Note** : Datastream doesn't support binary log transaction compression. If you use Datastream, then see [MySQL source behavior and
> limitations](https://docs.cloud.google.com/datastream/docs/faq#mysql-source).

No [binlog_transaction_compression_level_zstd](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_transaction_compression_level_zstd) `integer`   
`1` ... `22`   
default: `3`

Changes to `binlog_transaction_compression_level_zstd` take
effect only after the next `START REPLICA` statement.

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.20 and later for Cloud SQL.

No [binlog_transaction_dependency_history_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_transaction_dependency_history_size) `integer`  
`1` ... `10000000` default:  
- MySQL 8.4 and earlier: `25000`  
- MySQL 9.7 and later: `10000000`

For information about how to use this flag and its acceptable values,
see [Configure parallel replication](https://docs.cloud.google.com/sql/docs/mysql/replication/manage-replicas.md.txt#configuring-parallel-replication).
No [binlog_transaction_dependency_tracking](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_binlog_transaction_dependency_tracking) `enumeration`

For information about how to use this flag and its acceptable values,
see [Configure parallel replication](https://docs.cloud.google.com/sql/docs/mysql/replication/manage-replicas.md.txt#configuring-parallel-replication). This flag is not supported in MySQL 8.4 and later.
No [block_encryption_mode](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_block_encryption_mode) `string`  
`aes-keylen-mode`   
default: `aes-128-ECB`   

> [!NOTE]
> **Note:** This flag
> takes a value in `aes-keylen-mode` format, where `keylen`
> is the key length (in bits) and `mode` is the encryption mode.
> The value isn't case-sensitive.
>
> Allowed `keylen` values are `128`, `192`,
> and `256`.
>
> Allowed `mode` values are `ECB`, `CBC`,
> `CFB1`, `CFB8`, `CFB128`, and
> `OFB`.

No [bulk_insert_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_bulk_insert_buffer_size) `integer`  
`0` ... ` 4294967295`   
default: `8388608` No [caching_sha2_password_storage_format](https://dev.mysql.com/doc/refman/9.7/en/server-system-variables.html#sysvar_caching_sha2_password_storage_format) `string`   
`CRYPT5` \| `PBKDF2_SHA512`  
default: `CRYPT5`

> [!NOTE]
> **Note:** The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [caching_sha2_password_enforce_storage_format](https://dev.mysql.com/doc/refman/9.7/en/server-system-variables.html#sysvar_caching_sha2_password_enforce_storage_format) `boolean`   
`1` (true) \| `0` (false)   
default: `0` (false)

> [!NOTE]
> **Note:** The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [caching_sha2_password_proxy_users](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-caching-sha2-password-proxy) `boolean`   
`on` \| `off`   
default: `OFF`

For more information about this flag, see the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-caching-sha2-password-proxy) section.

> [!NOTE]
> **Note:** The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [collation_connection](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_collation_connection) `string`   
default:   
MySQL 8.0 and later - [utf8mb4_0900_ai_ci](https://dev.mysql.com/doc/refman/8.4/en/charset-unicode-utf8mb4.html)

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [collation_server](https://dev.mysql.com/doc/refman/8.4/en//server-system-variables.html#sysvar_collation_server) `string`   
default:   
MySQL 5.7 - [utf8_general_ci](https://dev.mysql.com/doc/refman/5.7/en/charset-unicode-utf8.html)  
MySQL 8.0 and later - [utf8mb4_0900_ai_ci](https://dev.mysql.com/doc/refman/8.0/en/charset-unicode-utf8mb4.html)   

> [!NOTE]
> **Note:** The `collation_server` flag should always be set to a value that is compatible with the `character_set_server`.

No [character_set_client](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_character_set_client) `string`  

default:   
MySQL 5.7: `utf8`   
MySQL 8.0 and later: `utf8mb4`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [character_set_connection](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_character_set_connection) `string`   
default:   
MySQL 5.7: `utf8`   
MySQL 8.0 and later: `utf8mb4`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [character_set_results](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_character_set_results) `string`  
[utf8](https://dev.mysql.com/doc/refman/8.4/en/charset-unicode-utf8.html) or [utf8mb4](https://dev.mysql.com/doc/refman/8.4/en/charset-unicode-utf8mb4.html)   
default:   
MySQL 5.7: `utf8`   
MySQL 8.0 and later: `utf8mb4`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [character_set_server](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_character_set_server) `string`  
[utf8](https://dev.mysql.com/doc/refman/8.4/en/charset-unicode-utf8.html) or [utf8mb4](https://dev.mysql.com/doc/refman/8.4/en/charset-unicode-utf8mb4.html) (recommended) Yes [check_proxy_users](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_check_proxy_users) `boolean`   
`on` \| `off`   
default: `off` No [cloudsql_allow_analyze_table](https://dev.mysql.com/doc/refman/8.4/en/analyze-table.html) `boolean` `on` \| `off`   
default: `off`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [cloudsql_avoid_parse_session_logging](https://docs.cloud.google.com/sql/docs/mysql/manage-data-using-studio.md.txt#validate-query-syntax) `boolean` `on` \| `off`   
default: `off` No [cloudsql_iam_authentication](https://docs.cloud.google.com/sql/docs/mysql/create-edit-iam-instances.md.txt#configure-iam-db-instance) `boolean` `on` \| `off`   
default: `off`   
Supported in MySQL 5.7 and later for Cloud SQL. No [cloudsql_ignore_innodb_encryption](https://dev.mysql.com/doc/refman/8.0/en/innodb-data-encryption.html) `boolean` `on` \| `off`   
default: `off`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [cloudsql_index_recreate_enable](https://docs.cloud.google.com/sql/docs/mysql/replication/create-manage-read-replica-indexes.md.txt#database-configuration-flags) `boolean`   
`on` \| `off`   
default: `on` No [cloudsql_index_recreate_replica_group](https://docs.cloud.google.com/sql/docs/mysql/replication/create-manage-read-replica-indexes.md.txt#database-configuration-flags) `string`   
default: `NULL` No [cloudsql_mysql_audit_data_masking_cmds](https://docs.cloud.google.com/sql/docs/mysql/use-db-audit.md.txt#audit_plugin_settings) `string`   
`""`, `dql`, `dml`, `ddl`, `dcl`, `show`, `call`, `create_udf`, `drop_function`, `create_procedure`, `create_function`, `drop_procedure`, `alter_procedure`, `alter_function`, `create_trigger`, `drop_trigger`, `create_event`, `alter_event`, `drop_event`, `create_db`, `drop_db`, `alter_db`, `create_user`, `drop_user`, `rename_user`, `alter_user`, `create_table`, `create_index`, `alter_table`, `drop_table`, `drop_index`, `create_view`, `drop_view`, `rename_table`, `update`, `insert`, `insert_select`, `delete`, `truncate`, `replace`, `replace_select`, `delete_multi`, `update_multi`, `load`, `select`, `call_procedure`, `connect`, `disconnect`, `grant`, `revoke`, `revoke_all`, `show_triggers`, `show_create_proc`, `show_create_func`, `show_procedure_code`, `show_function_code`, `show_create_event`, `show_events`, `show_create_trigger`, `show_grants`, `show_binlog_events`, `show_relaylog_events`   

default: `create_user`, `alter_user`, `grant`, and `update` No [cloudsql_mysql_audit_data_masking_regex](https://docs.cloud.google.com/sql/docs/mysql/use-db-audit.md.txt#audit_plugin_settings) `string`   
`max_string_length: 2048`   
default: See [Audit plugin settings](https://docs.cloud.google.com/sql/docs/mysql/use-db-audit.md.txt#audit_plugin_settings). No [cloudsql_mysql_audit_log_write_period](https://docs.cloud.google.com/sql/docs/mysql/use-db-audit.md.txt#audit_plugin_settings) `integer`   
`0...5000` milliseconds   
default: `500` milliseconds No [cloudsql_mysql_audit_max_query_length](https://docs.cloud.google.com/sql/docs/mysql/use-db-audit.md.txt#audit_plugin_settings) `integer`   
`-1...1073741824`   
default: `-1` No [cloudsql_parameterized_secure_view](https://docs.cloud.google.com/sql/docs/mysql/parameterized-secure-views.md.txt) `boolean`  
`on` \| `off`   
default: `off`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0.43 and later for Cloud SQL.

No [cloudsql_vector](https://docs.cloud.google.com/sql/docs/mysql/work-with-vectors) `boolean` `on` \| `off`   
default: `off`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0.36 and later for Cloud SQL.

Yes [cloudsql_vector_iterative_filtering](https://docs.cloud.google.com/sql/docs/mysql/search-filter-vector-embeddings.md.txt#ann-iterative-filtering) `boolean`   

default: `off`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0.36 and later for Cloud SQL.

No [cloudsql_vector_iterative_filtering_max_neighbors](https://docs.cloud.google.com/sql/docs/mysql/search-filter-vector-embeddings.md.txt#ann-iterative-filtering) `integer`   
`10...1000`   
default: `500`   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0.36 and later for Cloud SQL.

No [cloudsql_vector_max_mem_size](https://docs.cloud.google.com/sql/docs/mysql/work-with-vectors) `integer`   
`1073741824...innodb_buffer_pool_size/2`   
default: `1073741824` in bytes   

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0.36 and later for Cloud SQL.

Yes [completion_type](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_completion_type) `enumeration`  
`NO_CHAIN` (default), `CHAIN`, or `RELEASE` No [concurrent_insert](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_concurrent_insert) `enumeration`  
`NEVER`, `AUTO` (default), or `ALWAYS` No [connect_timeout](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_connect_timeout) `integer`  
`2` ... `31536000`   
default: `10` No [connection_memory_chunk_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_connection_memory_chunk_size) `integer`  
`0` ... `536870912`   
Default:   
MySQL 8.0.28 to 8.0.33: `8912`  
MySQL 8.0.34 and later: `8192`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.28 and later for Cloud SQL.

No [connection_memory_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_connection_memory_limit) `integer`  
`2097152` ... `9223372036854775807`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.28 and later for Cloud SQL.

No [connection_memory_status_limit](https://dev.mysql.com/doc/refman/9.7/en/server-system-variables.html#sysvar_connection_memory_status_limit) `integer`  
`16777216` ... `9223372036854775807`   
default: `9223372036854775807`

> [!NOTE]
> **Note**: The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [cte_max_recursion_depth](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_cte_max_recursion_depth) `integer`  
`0` ... `4294967295`   
default: `1000` No [default_authentication_plugin](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_default_authentication_plugin) `string`   
`mysql_native_password|caching_sha2_password`   

> [!NOTE]
> **Note**: This flag is supported in MySQL 8.0 for Cloud SQL only. The flag is not supported in MySQL 8.4 and later.

Yes [default_password_lifetime](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_default_password_lifetime) `integer` `0...65535`   
default: `0`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [default_time_zone](https://dev.mysql.com/doc/refman/8.4/en/server-options.html#option_mysqld_default-time-zone) `string`  
There are two ways to specify timezones: as timezone offsets and timezone names. For example, `+00:00` is the timezone offset for London (which is in the UTC timezone), and `Europe/London` is its timezone name.

You use values to specify timezone offsets, from `-12:59`
to `+13:00`. Leading zeros are required.

When using timezone names, automatic adjustment to daylight saving
time is supported. When using timezone offsets, it isn't supported.
See a list of [timezone names](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#timezone-names) that
Cloud SQL for MySQL supports. You must update this flag
manually, on the primary instance and on all read replicas, to
account for it.

To set the timezone without causing a restart of the Cloud SQL
instance, use the `set time_zone=timezone_offset`
or `timezone_name` command with the
`init_connect` flag.
Yes [default_tmp_storage_engine](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_default_tmp_storage_engine) `string`   
`INNODB|MEMORY`   
default: `INNODB` No [default_week_format](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_default_week_format) `integer`  
`0` ... `7`   
default: `0` No [delay_key_write](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_delay_key_write) `enumeration`  
`OFF`, `ON` (default), or `ALL` No [disconnect_on_expired_password](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_disconnect_on_expired_password) `boolean` `on` \| `off`   
default: `on`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

Yes [div_precision_increment](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_div_precision_increment) `integer`  
`0` ... `30`   
default: `4` No [end_markers_in_json](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_end_markers_in_json) `boolean`   
`on` \| `off`   
default: `off` No [eq_range_index_dive_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_eq_range_index_dive_limit) `integer`  
`0` ... ` 2147483647` No [event_scheduler](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_event_scheduler) `boolean`  
`on` \| `off`

If you are using the Event Scheduler, configure your
instance with an
[activation policy](https://docs.cloud.google.com/sql/docs/mysql/start-stop-restart-instance.md.txt#activation_policy) of ALWAYS to ensure that scheduled events run.

See the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-event-scheduler)
section for more information about this flag.
No [expire_logs_days](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_expire_logs_days) `integer`  
`0` ... `99`   
Default is 0, which means no automatic removal.

**Note** : This flag is not supported in MySQL 8.4.
Use `binlog_expire_logs_seconds` instead. See the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-expire-logs)
section for more information about this flag.
No [explicit_defaults_for_timestamp](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_explicit_defaults_for_timestamp) `boolean`  
`on` \| `off`  

> [!NOTE]
> **Note:** The flag only requires a restart for MySQL 5.6.x or earlier.

No [flush_time](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_flush_time) `integer`  
`0` ... `31536000`   
default: `0` No [foreign_key_checks](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_foreign_key_checks) `boolean`   
`on` \| `off`   
default: `on`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [ft_max_word_len](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_ft_max_word_len) `integer`  
`10` ... ` 252` Yes [ft_min_word_len](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_ft_min_word_len) `integer`  
`1` ... ` 16` Yes [ft_query_expansion_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_ft_query_expansion_limit) `integer`  
`0` ... ` 1000` Yes [ft_stopword_file](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_ft_stopword_file) `string`  
Yes [general_log](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_general_log) `boolean`  
`on` \| `off`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-general-log) section for more information about general logs.
No [generated_random_password_length](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_generated_random_password_length) `integer` ` 5-255`   
default: `20`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [global_connection_memory_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_global_connection_memory_limit) `integer`  
`16777216` ... ` 9223372036854775807`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.28 and later for Cloud SQL.

No [global_connection_memory_status_limit](https://dev.mysql.com/doc/refman/9.7/en/server-system-variables.html#sysvar_global_connection_memory_status_limit) `integer`  
`16777216` ... `9223372036854775807`   
default: `9223372036854775807`

> [!NOTE]
> **Note**: The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [global_connection_memory_tracking](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_global_connection_memory_tracking) `boolean`  
`on` \| `off`   
Default: `off`   

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.28 and later for Cloud SQL.

No [group_concat_max_len](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_group_concat_max_len) `integer`  
`4` ... ` 17179869184` No [gtid_executed_compression_period](https://dev.mysql.com/doc/refman/8.4/en/replication-options-gtids.html#sysvar_gtid_executed_compression_period) `integer`  
`0` ... `4294967295`   
default (up to version 8.0.22): `1000`   
default (version 8.0.23+): `0` No [histogram_generation_max_mem_size](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_histogram_generation_max_mem_size) `integer`  
`1000000` ... `4294967295`   
default: `20000000` No [init_connect](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_init_connect) `string` No [innodb_adaptive_hash_index](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_adaptive_hash_index) `boolean`  
`on` \| `off` No [innodb_adaptive_hash_index_parts](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_adaptive_hash_index_parts) `integer`  
`1` ... ` 512` Yes [innodb_adaptive_max_sleep_delay](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_adaptive_max_sleep_delay) `integer`  
`0` ... ` 1000000` No [innodb_autoextend_increment](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_autoextend_increment) `integer`  
`1` ... `1000` No [innodb_autoinc_lock_mode](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_autoinc_lock_mode) `integer`  
`0` ... ` 2` Yes [innodb_buffer_pool_chunk_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_chunk_size) `integer`  
`1048576` ... `(innodb_buffer_pool_size/innodb_buffer_pool_instances)`  

This flag value is dependent on `innodb_buffer_pool_size`
and `innodb_buffer_pool_instances`. MySQL can auto-tune the
value of `innodb_buffer_pool_chunk_size` based on these two
flags.
Yes [innodb_buffer_pool_dump_pct](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_dump_pct) `integer`  
`1` ... ` 100`   
Default: `25` No [innodb_buffer_pool_dump_at_shutdown](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_dump_at_shutdown) `boolean`  
`on` \| `off` No [innodb_buffer_pool_dump_now](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_dump_now) `boolean`  
`on` \| `off`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set)
section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_buffer_pool_instances](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_instances) `integer`  
`1` ... ` 64` Yes [innodb_buffer_pool_load_abort](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_load_abort) `boolean`  
`on` \| `off`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set)
section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_buffer_pool_load_at_startup](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_load_at_startup) `boolean`  
`on` \| `off` Yes [innodb_buffer_pool_load_now](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_load_now) `boolean`  
`on` \| `off`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set)
section for more information about this flag.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_buffer_pool_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_buffer_pool_size) `integer`

Setting this flag for MySQL 5.6 requires a restart. See the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-buffer-pool) section for
more information about this flag.
No [innodb_change_buffer_max_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_change_buffer_max_size) `integer`  
`0` ... ` 50`  
default:  
- MySQL 8.4 and earlier: `25`  
- MySQL 9.7 and later: `5` No [innodb_change_buffering](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_change_buffering) `string`  

Options: `none`,
`inserts`, `deletes`, `changes`,
`purges`, `all`.
default:  
- MySQL 8.0 and earlier: `none`  
- MySQL 8.4 and later: `all` No [innodb_checksum_algorithm](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_checksum_algorithm) `string`  

Options: `crc32`,
`strict_crc32`, `innodb`,
`strict_innod`, `none`, `strict_none`.
No [innodb_cloudsql_managed_buffer_pool](https://docs.cloud.google.com/sql/docs/mysql/optimize-high-memory-usage.md.txt#enable-managed-buffer-pool) `boolean`  
`on` \| `off`   
Default: `off`

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_cloudsql_managed_buffer_pool_threshold_pct](https://docs.cloud.google.com/sql/docs/mysql/optimize-high-memory-usage.md.txt#enable-managed-buffer-pool) `integer`  
`50` ... `99` Instance RAM RangeDefault \< 3 GB RAMN/A (shared-core not supported) 3-8 GB RAM`90` 8-15 GB RAM`92` 15-100 GB RAM`95` \> 100 GB RAM`97`

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_cloudsql_managed_buffer_pool_tuneup_pct](https://docs.cloud.google.com/sql/docs/mysql/optimize-high-memory-usage.md.txt#enable-managed-buffer-pool) `integer`  
`48` ... `97`   
Default: `70`

This flag must be set to a value at least 2 less than the value of
`innodb_cloudsql_managed_buffer_pool_threshold_pct`.

> [!NOTE]
> **Note:** The flag is supported in MySQL 8.0 and later for Cloud SQL. This flag requires maintenance version `R20260726.00_05` or later.

No [innodb_cloudsql_optimized_write](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-optimized-write) `boolean`

This flag is available only for instances with Cloud SQL Enterprise Plus edition.
For more information about this flag, see the
[Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-optimized-write) section.
Yes [innodb_cmp_per_index_enabled](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_cmp_per_index_enabled) `boolean`  
`on` \| `off` No [innodb_commit_concurrency](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_commit_concurrency) `integer`  
`0` ... `1000` Yes [innodb_compression_failure_threshold_pct](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_compression_failure_threshold_pct) `integer`  
`0` ... `100` No [innodb_compression_level](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_compression_level) `integer`  
`0` ... `9` No [innodb_compression_pad_pct_max](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_compression_pad_pct_max) `integer`  
`0` ... `75` No [innodb_concurrency_tickets](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_concurrency_tickets) `integer`  
`1` ... ` 4294967295` No [innodb_ddl_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ddl_buffer_size) `integer`   
`65536` ... `4294967295`   
default: `1048576`

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.27 and later for Cloud SQL.

No [innodb_ddl_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ddl_threads) `integer`   
`1` ... `64`   
default: `4`

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0.27 and later for Cloud SQL.

No [innodb_deadlock_detect](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_deadlock_detect) `boolean`  
`on` \| `off`

Supported in MySQL [5.7](https://dev.mysql.com/doc/refman/5.7/en/innodb-parameters.html#sysvar_innodb_deadlock_detect) and later.

Default: `on`
No [innodb_disable_sort_file_cache](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_disable_sort_file_cache) `boolean`  
`on` \| `off` No [innodb_doublewrite_batch_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_doublewrite_batch_size) `integer`  
`0` ... ` 256`  
Default: `0` Yes [innodb_doublewrite_files](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_doublewrite_files) `integer`  
`2` ... ` 128` Yes [innodb_doublewrite_pages](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_doublewrite_pages) `integer`  
`4` ... ` 512`  
Default: `64` Yes [innodb_file_per_table](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_file_per_table) `boolean`  
`on` \| `off`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-file-per-table) section for more information about this flag.
No [innodb_fill_factor](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_fill_factor) `integer`  
`10` ... ` 100` No [innodb_flush_log_at_timeout](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flush_log_at_timeout) `double`  
`0.0001`... `2700`  
Default: `1`

Supported in MySQL [5.7](https://dev.mysql.com/doc/refman/5.7/en/innodb-parameters.html#sysvar_innodb_flush_log_at_timeout)
and later.

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-flush-log-timeout) section for more information about this flag.
No [innodb_flush_log_at_trx_commit](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flush_log_at_trx_commit) `integer`  
`0, 1, 2`  
Default: `1`

If you promote a replica with this flag enabled,
the flag is automatically removed causing the promoted replica to have
full durability by default. To use this flag with a promoted replica,
you can update the flag to the replica after promotion.

> [!NOTE]
> **Note:** If you change the default value for the `innodb_flush_log_at_trx_commit` flag on an HA-enabled instance, then the instance loses SLA coverage because durability might decrease.

> [!NOTE]
> **Note:** A value of `0` for the `innodb_flush_log_at_trx_commit` flag is only valid for read replicas.

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-flush-log)
section for more information.
No [innodb_flush_method](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flush_method) `string`

Options: `fsync`,
`O_DIRECT`, `O_DSYNC`
Default: `O_DIRECT` Yes [innodb_flush_neighbors](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flush_neighbors) `enumeration`  
`0` ... `2`  
Default values:  
- MySQL 5.6: `0`  
- MySQL 5.7 to MySQL 8.0:`2`  
- MySQL 8.4 and later: `0` No [innodb_flush_sync](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flush_sync) `boolean`  
`on` \| `off` No [innodb_flushing_avg_loops](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_flushing_avg_loops) `integer`  
`1` ... ` 1000`  
Default: `30` No [innodb_fsync_threshold](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_fsync_threshold) `integer`  
`0` ... ` 9223372036854775807`  
Default: `0`

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_ft_aux_table](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_aux_table) `string`  

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-option-set) section for more information about this flag.

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

Yes [innodb_ft_cache_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_cache_size) `integer`  
`1600000` ... ` 80000000` Yes [innodb_ft_enable_diag_print](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_enable_diag_print) `boolean`  
`on` \| `off` No [innodb_ft_enable_stopword](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_enable_stopword) `boolean`  
`on` \| `off` No [innodb_ft_max_token_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_max_token_size) `integer`  
`10` ... ` 252` Yes [innodb_ft_min_token_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_min_token_size) `integer`  
`0` ... ` 16` Yes [innodb_ft_num_word_optimize](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_num_word_optimize) `integer`  
`1000` ... ` 10000` No [innodb_ft_result_cache_limit](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_result_cache_limit) `integer`  
`1000000` ... ` 4294967295` No [innodb_ft_server_stopword_table](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_server_stopword_table) `string` No [innodb_ft_sort_pll_degree](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_sort_pll_degree) `integer`  
`1` ... `32` Yes [innodb_ft_total_cache_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_total_cache_size) `integer`  
`32000000` ... ` 1600000000` Yes [innodb_ft_user_stopword_table](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_ft_user_stopword_table) `string` No [innodb_idle_flush_pct](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_idle_flush_pct) `integer`  
`0` ... ` 100`   
Default: `100`

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_io_capacity](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_io_capacity) `integer`  
`100` ... ` 100000`   
Default: `5000`

To learn more about configuring the disk performance, see the **E2 VMs** table in
[Configure disks to meet performance requirements.](https://docs.cloud.google.com/compute/docs/disks/performance.md.txt#e2_vms)
No [innodb_io_capacity_max](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_io_capacity_max) `integer`  
`100` ... ` 100000`   
Default: `10000`

To learn more about configuring the disk performance, see the **E2 VMs** table in
[Configure disks to meet performance requirements.](https://docs.cloud.google.com/compute/docs/disks/performance.md.txt#e2_vms)
No [innodb_large_prefix](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_large_prefix) `boolean`  
`on` \| `off`

Supported only in MySQL 5.6.
No [innodb_lock_wait_timeout](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_lock_wait_timeout) `integer`  
`1` ... `1073741824` No [innodb_log_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_buffer_size) `integer`  
- MySQL 5.6: `262144` ... `4294967295`  
- MySQL 5.7 and later: `1048576` ... `4294967295` **MySQL 5.7 and earlier** : Yes  

**MySQL 8.0 and later**: No [innodb_log_checksums](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_checksums) `boolean`  
`on` \| `off`   
default: `on` No [innodb_log_file_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_file_size) `integer`  
- MySQL 5.6: `1048576` ... `274877906944`  
- MySQL 5.7 to 8.4: `4194304` ... `274877906944`  
- MySQL 9.7: removed from database  

For more information about this flag, see the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-redo-logs) section.
Yes [innodb_log_spin_cpu_abs_lwm](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_spin_cpu_abs_lwm) `integer`   
`0` ... `4294967295`   
default: `80` No [innodb_log_spin_cpu_pct_hwm](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_spin_cpu_pct_hwm) `integer`   
`0` ... `100`   
default: `50` No [innodb_log_wait_for_flush_spin_hwm](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_wait_for_flush_spin_hwm) `integer`   
`0` ... `4294967295`   
default: `400` No [innodb_log_write_ahead_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_write_ahead_size) `integer`   
`512` ... `65536`   
default: `8192` No [innodb_log_writer_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_log_writer_threads) `boolean`  
`on` \| `off`   
default: `on`

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [innodb_lru_scan_depth](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_lru_scan_depth) `integer`  
`100` ... ` 9223372036854775807` No [innodb_max_dirty_pages_pct](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_max_dirty_pages_pct) `float`  
`0` ... `99.99`   
default: `90` No [innodb_max_dirty_pages_pct_lwm](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_max_dirty_pages_pct_lwm) `float`  
`0` ... `99.99`   
default: `10` No [innodb_max_purge_lag](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_max_purge_lag) `integer`   
`0` ... `4294967295`   
default: `0` No [innodb_max_undo_log_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_max_undo_log_size) `integer`   
`10485760` ... `9223372036854775807`   
default: `1073741824` No [innodb_max_purge_lag_delay](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_max_purge_lag_delay) `integer`   
`0` ... `10000000`   
default: `0` No [innodb_monitor_disable](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_monitor_disable) `string` No [innodb_monitor_enable](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_monitor_enable) `string` No [innodb_monitor_reset](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_monitor_reset) `string`   
`counter`, `module`, `pattern`, `all` No [innodb_monitor_reset_all](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_monitor_reset_all) `enumeration`   
Valid values: `counter`, `module`, `pattern`, `all` No [innodb_native_foreign_keys](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_old_blocks_pct) `boolean`  
`on` \| `off`  
default: `off`

> [!NOTE]
> **Note**: The flag is supported in MySQL 9.7 and later for Cloud SQL.

No [innodb_old_blocks_pct](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_old_blocks_pct) `integer`  
`5` ... ` 95` No [innodb_old_blocks_time](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_old_blocks_time) `integer`  
`0` ... ` 4294967295` No [innodb_online_alter_log_max_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_online_alter_log_max_size) `integer`  
`65536` ... ` 9223372036854775807` No [innodb_open_files](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_open_files) `integer`  
`100` ... `2147483647`   
default:   
MySQL 5.7: `2000`   
MySQL 8.0 and later: `4000` ≥ `8.0.28`: No   
≤ `8.0.27`: Yes [innodb_optimize_fulltext_only](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_optimize_fulltext_only) `boolean`  
`on` \| `off` No [innodb_page_cleaners](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_page_cleaners) `integer`  
`1` ... ` 64`  
Supported in MySQL [5.7](https://dev.mysql.com/doc/refman/5.7/en/innodb-parameters.html#sysvar_innodb_page_cleaners) and later. For MySQL 5.7 and 8.0, the default is `4`. For MySQL 8.4, the default is equal to the value of configured for the `innodb_buffer_pool_instances` flag. Yes [innodb_parallel_read_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_parallel_read_threads) `integer`  
`1` ... `256`   
default: `4` No [innodb_print_all_deadlocks](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_print_all_deadlocks) `boolean`  
`on` \| `off`   
default: `off` No [innodb_print_ddl_logs](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_print_ddl_logs) `boolean`  
`on` \| `off` No [innodb_purge_batch_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_purge_batch_size) `integer`  
`1` ... `5000`   
default: `300` No [innodb_purge_rseg_truncate_frequency](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_purge_rseg_truncate_frequency) `integer`  
`1` ... `128`   
default: `128` No [innodb_purge_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_purge_threads) `integer`  
`1` ... `32`   
Default values:  
- MySQL 5.6:` 1`  
- MySQL 5.7 and later:` 4` Yes [innodb_random_read_ahead](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_random_read_ahead) `boolean`  
`on` \| `off` No [innodb_read_ahead_threshold](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_read_ahead_threshold) `integer`  
`0` ... ` 64` No [innodb_read_io_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_read_io_threads) `integer`  
`1` ... `64` Yes [innodb_redo_log_capacity](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_redo_log_capacity) `integer`  
- MySQL 8.0.33 and earlier: `8388608` (8 MB) ... `137438953472` (128 GB)  
- MySQL 8.0.34 and later: `8388608` (8 MB) ... `549755813888` (512 GB)

For more information about this flag, see the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-redo-logs) section.
No [innodb_replication_delay](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_replication_delay) `integer`  
`0` ... ` 4294967295` No [innodb_rollback_on_timeout](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_rollback_on_timeout) `boolean`  
`on` \| `off` Yes [innodb_rollback_segments](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_rollback_segments) `integer`  
`1` ... ` 128` No [innodb_segment_reserve_factor](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_segment_reserve_factor) `float`  
`.03` ... ` 40`   
default: `12.5` No [innodb_sort_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_sort_buffer_size) `integer`  
`65536` ... ` 67108864` Yes [innodb_spin_wait_delay](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_spin_wait_delay) `integer`  
- MySQL 5.7: `0` ... ` 1000000`  
- MySQL 8.0.13+: `0` ... ` 1000`   
default: `6` No [innodb_stats_auto_recalc](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_auto_recalc) `boolean`  
`on` \| `off` No [innodb_stats_include_delete_marked](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_include_delete_marked) `boolean`  
`on` \| `off`   
default: `off` No [innodb_stats_method](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_method) `enumeration`  
`nulls_equal` \| `nulls_unequal` \| `nulls_ignored` No [innodb_stats_on_metadata](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_on_metadata) `boolean`  
`on` \| `off` No [innodb_stats_persistent](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_persistent) `boolean`  
`on` \| `off` No [innodb_stats_persistent_sample_pages](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_persistent_sample_pages) `integer`  
`1` ... ` 9223372036854775807` No [innodb_stats_sample_pages](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_sample_pages) `integer`  
`1` ... ` 9223372036854775807` No [innodb_stats_transient_sample_pages](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_stats_transient_sample_pages) `integer`  
`1` ... ` 9223372036854775807` No [innodb_status_output](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_status_output) `boolean`  
`on` \| `off` No [innodb_status_output_locks](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_status_output_locks) `boolean`  
`on` \| `off` No [innodb_strict_mode](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_strict_mode) `boolean`  
`on` \| `off` No [innodb_sync_array_size](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_sync_array_size) `1 ... 1024`

Default is **1**.
Yes [innodb_sync_spin_loops](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_sync_spin_loops) `integer`  
`0` ... ` 4294967295`   
default: `30` No [innodb_table_locks](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_table_locks) `boolean`  
`on` \| `off`   
default: `on` No [innodb_thread_concurrency](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_thread_concurrency) `integer`  
`0` ... ` 1000` No [innodb_thread_sleep_delay](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_thread_sleep_delay) `integer`  
`0` ... ` 1000000` No [innodb_undo_log_truncate](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_undo_log_truncate) `boolean`  
`on` \| `off`   
default: `on` No [innodb_use_native_aio](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_use_native_aio) `boolean`  
`on` \| `off`   
default: `on` Yes [innodb_write_io_threads](https://dev.mysql.com/doc/refman/8.4/en/innodb-parameters.html#sysvar_innodb_write_io_threads) `integer`  
`1` ... ` 64` Yes [interactive_timeout](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_interactive_timeout) `integer`  
`1` ... ` 31536000` No [internal_tmp_disk_storage_engine](https://dev.mysql.com/doc/refman/5.7/en/server-system-variables.html#sysvar_internal_tmp_disk_storage_engine) `enumeration`  
`INNODB` \| `MYISAM`  
Default: `INNODB`  

> [!NOTE]
> **Note**: This flag is supported in MySQL 5.7 for Cloud SQL only.

No [internal_tmp_mem_storage_engine](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_internal_tmp_mem_storage_engine) `enumeration`  
`MEMORY`, `TempTable`  

> [!NOTE]
> **Note**: The flag is supported in MySQL 8.0 and later for Cloud SQL.

. No [join_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_join_buffer_size) `integer`  
`128` ... ` 9223372036854775807` No [keep_files_on_create](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_keep_files_on_create) `boolean`   
`on` \| `off`   
default: `off` No [key_buffer_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_key_buffer_size) `integer`  
`4096` ... ` 4294967295`   
default: `8388608` No [key_cache_age_threshold](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_key_cache_age_threshold) `integer`  
`100` ... ` 9223372036854775807`   
default: `300` No [key_cache_block_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_key_cache_block_size) `integer`  
`512` ... ` 16384`   
default: `1024` No [key_cache_division_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_key_cache_division_limit) `integer`  
`1` ... ` 100`   
default: `100` No [lc_times_names](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_lc_time_names) `string`  
`en_US` \| `cs_CZ` \| `da_DK` \| `nl_NL` \| `et_EE` \| `fr_FR` \| `de_DE` \| `el_GR` \| `hu_HU` \| `it_IT` \| `ja_JP` \| `ko_KR` \| `no_NO` \| `nb_NO` \| `pl_PL` \| `pt_PT` \| `ro_RO` \| `ru_RU` \| `sr_RS` \| `sk_SK` \| `es_ES` \| `sv_SE` \| `uk_UA`   
default: `en_US` No [local_infile](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_local_infile) `boolean`  
`on` \| `off` No [lock_wait_timeout](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_lock_wait_timeout) `integer`  
`1` ... ` 31536000` No [log_bin_trust_function_creators](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_log_bin_trust_function_creators) `boolean`  
`on` \| `off` No [log_output](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_output) `set`  
`FILE` \| `TABLE` \| `NONE` No [log_error_verbosity](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_error_verbosity) `integer`  
`1` ... ` 3`   
default:   
MySQL 5.7: `3`  
MySQL 8.0 and later: `2` No [log_queries_not_using_indexes](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_queries_not_using_indexes) `boolean`  
`on` \| `off` No [log_slow_admin_statements](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_slow_admin_statements) `boolean`  
`on` \| `off`   
default: `off` No [log_slow_extra](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_slow_extra) `boolean`  
`on` \| `off`   
default: `off` No [log_slow_replica_statements](https://dev.mysql.com/doc/refman/8.0/en/replication-options-replica.html#sysvar_log_slow_replica_statements) `boolean`   
`on` \| `off` Default: `off`

> [!NOTE]
> This flag name is only available for MySQL 8.0.26 and later. For MySQL versions 8.0.18 and earlier, use the `log_slow_slave_statements` flag. For more information, see [Aliased flags](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#aliased-flags).

No [log_slow_slave_statements](https://dev.mysql.com/doc/refman/8.0/en/replication-options-replica.html#sysvar_log_slow_slave_statements) `boolean`   
`on` \| `off` Default: `off`

> [!NOTE]
> This flag name is deprecated for MySQL 8.0.26 and later. Instead, use the `log_slow_replica_statements` flag. For more information, see [Aliased flags](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#aliased-flags).

No [log_throttle_queries_not_using_indexes](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_throttle_queries_not_using_indexes) `integer`  
`0` ... ` 9223372036854775807` No [log_timestamps](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_log_timestamps) `string`  
`"UTC | SYSTEM"`   
default: `UTC` No [long_query_time](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_long_query_time) `float`  
`0` ... `30000000`

Cloud SQL provides the ability to set this flag to less than 1 if needed.

If the `log_queries_not_using_indexes` flag is also
enabled, you may see queries with less than the time specified here.
No lower_case_table_names [5.7](https://dev.mysql.com/doc/refman/5.7/en/server-system-variables.html#sysvar_lower_case_table_names) \| [8.0](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_lower_case_table_names) `integer`  
`0` or `1`   
Default: `0`

If you use the default value of `0` for this flag,
table and database names are
case sensitive. When set to `1`,
table and database names are case insensitive.

For MySQL 5.7 instances, you can change the value of this flag at any
time. If you do, then make sure that you understand how the change affects your
existing tables and databases.

**For MySQL 8.0 and later instances, you can set the value of this flag
to a desired value only while an instance is being created.** After you set this value,
you can't change it. Also, for an existing instance, you can't change the value of this flag.

When creating read replicas for MySQL 5.7, MySQL 8.0, or MySQL 8.4 instances,
the replica inherits this flag value from the primary.
Yes [mandatory_roles](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_mandatory_roles) `string` `*role name*`   
default: `empty string`   

> [!NOTE]
> **Note:**The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [master_verify_checksum](https://dev.mysql.com/doc/refman/8.0/en/replication-options-binary-log.html#sysvar_master_verify_checksum) `boolean`   
`on` \| `off` Default: `off`

> [!NOTE]
> This flag name is deprecated for MySQL 8.0.26 and later. Instead, use the `source_verify_checksum` flag. For more information, see [Aliased flags](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#aliased-flags).

No [max_allowed_packet](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_allowed_packet) `integer`  
`16384` ... ` 1073741824`

This value must be a multiple of 1024, if sql_mode=TRADITIONAL or sql_mode=STRICT_ALL_TABLES.
No [max_binlog_cache_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_max_binlog_cache_size) `integer`  
`4096` ... ` 4294967296`   
default: `4294967296` No [max_binlog_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_max_binlog_size) `integer`  
`4096` ... ` 1073741824` No [max_binlog_stmt_cache_size](https://dev.mysql.com/doc/refman/8.4/en/replication-options-binary-log.html#sysvar_max_binlog_stmt_cache_size) `integer`  
`4096` ... ` 4294967296`   
default: `4294967296` No [max_connect_errors](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_connect_errors) `integer`  
`1` ... ` 9223372036854775807`   
default: `100` No [max_connections](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_connections) `integer`  
`1` ... ` 100000` No [max_digest_length](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_digest_length) `integer`  
`0` ... ` 1048576` Yes [max_error_count](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_error_count) `integer`  
`0` ... ` 65535`   
default:   
- MySQL 5.7 or lower: `64`  
- MySQL 8.0 and later: `1024` No [max_execution_time](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_execution_time) `integer`  
`0` ... ` 9223372036854775807` No [max_heap_table_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_heap_table_size) `integer`  
`16384` ... ` 67108864`

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-heap) section for more information about this flag.
No [max_join_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_join_size) `integer`  
`16` ... ` 9223372036854775807` No [max_length_for_sort_data](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_length_for_sort_data) `integer`  
`4` ... ` 8388608` No [max_points_in_geometry](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_points_in_geometry) `integer`  
`3` ... ` 1048576` No [max_prepared_stmt_count](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_prepared_stmt_count) `integer`  
- MySQL 5.6 and 5.7: `0` ... `1048576`  
- MySQL 8.0 and later: `0` ... `4194304` No [max_seeks_for_key](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_seeks_for_key) `integer`  
`1` ... ` 9223372036854775807` No [max_sort_length](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_sort_length) `integer`  
`4` ... ` 8388608` No [max_sp_recursion_depth](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_sp_recursion_depth) `integer`  
`0` ... ` 255` No [max_user_connections](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_user_connections) `integer`  
`0` ... ` 4294967295` No [max_write_lock_count](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_max_write_lock_count) `integer`  
`1` ... ` 9223372036854775807` No [min_examined_row_limit](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_min_examined_row_limit) `integer`  
`0` ... ` 4294967295`   
default: `0` No [myisam_data_pointer_size](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_myisam_data_pointer_size) `integer`   
`2...7`   
default: `6` No [myisam_max_sort_file_size](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_myisam_max_sort_file_size) `integer`   
`0...9223372036853727232`   
default: `9223372036853727232` No [myisam_mmap_size](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_myisam_mmap_size) `integer`   
`7...9223372036854775807`   
default: `9223372036854775807` Yes [myisam_sort_buffer_size](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_myisam_sort_buffer_size) `integer`   
`4096...4294967295`   
default: `8388608` No [myisam_stats_method](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_myisam_stats_method) `string`  
`"nulls_unequal, nulls_equal, nulls_ignored"`   
default: `nulls_unequal` No [myisam_use_mmap](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_myisam_use_mmap) `boolean`   
`on` \| `off`   
default: `off` No [mysql_native_password_proxy_users](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_mysql_native_password_proxy_users) `boolean`   
`on` \| `off`   
default: `off` No [net_buffer_length](https://dev.mysql.com/doc/refman/8.0/en/server-system-variables.html#sysvar_net_buffer_length) `integer`  
`1024` ... ` 1048576`   
default: `16384` No [net_read_timeout](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_net_read_timeout) `integer`  
`30` ... ` 4294967295` No [net_retry_count](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_net_retry_count) `integer`  
`10` ... ` 4294967295` No [net_write_timeout](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_net_write_timeout) `integer`  
`60` ... ` 4294967295` No [ngram_token_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_ngram_token_size) `integer`  
`1` ... ` 10`   
default: `2` Yes [optimizer_prune_level](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_optimizer_prune_level) `integer`  
`0` ... ` 1` No [optimizer_search_depth](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_optimizer_search_depth) `integer`  
`0` ... ` 62` No [optimizer_switch](https://dev.mysql.com/doc/refman/9.7/en/server-system-variables.html#sysvar_optimizer_switch) `multi-value repeated string`   

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-multi-value) section for more information about multi-value flags.
No [optimizer_trace](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_optimizer_trace) `multi-value repeated string`   
`enabled=on`, `enabled=off`, `one_line=on`, `one_line=off`  

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-multi-value) section for more information about multi-value flags.
No [optimizer_trace_features](https://dev.mysql.com/doc/refman/8.4/en/replication-options-gtids.html#sysvar_binlog_gtid_simple_recovery) `multi-value repeated string`   

See the [Tips](https://docs.cloud.google.com/sql/docs/mysql/flags.md.txt#tips-multi-value) section for more information about multi-value flags.
No [optimizer_trace_max_mem_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_optimizer_trace_max_mem_size) `integer`  
`0` ... ` 9223372036854775807` No [optimizer_trace_offset](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_optimizer_trace_offset) `integer`  
`-9223372036854775808` ... ` 9223372036854775807` No [parser_max_mem_size](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_parser_max_mem_size) `integer`  
`10000000` ... ` 9223372036854775807` No [password_history](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_password_history) `integer` `0-4294967295`   
default: `0`   

> [!NOTE]
> **Note:**The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [password_require_current](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_password_require_current) `boolean` `on` \| `off`   
default: `off`   

> [!NOTE]
> **Note:**The flag is supported in MySQL 8.0 and later for Cloud SQL.

No [password_reuse_interval](https://dev.mysql.com/doc/refman/8.4/en/server-system-variables.html#sysvar_password_reuse_interval) `integer` `0-4294967295`   
default: `0`   

> [!NOTE]
> **Note:**The flag is supported in MySQL 8.0 and later for Cloud SQL.

[...]
